<div>
    <mat-form-field style="min-width: 150px; max-width: 500px; width: 100%;" appearance="fill">
        <mat-label>Search city</mat-label>
        <input type="text" matInput [(ngModel)]="searchTerm" #searchInput />
        <button *ngIf="searchTerm" matSuffix mat-icon-button aria-label="Clear" (click)="clearSearchTerm()">
            <mat-icon>close</mat-icon>
        </button>
    </mat-form-field>
</div>

<div>{{status}}</div>

<br />

<div style="margin: auto;">
    <div *ngIf="searchTerm.length < 3">Type at least 3 chars</div>
    <div *ngIf="searchTerm.length >= 3 && !hasResult()">No result</div>
    <button mat-button *ngIf="hasResult()" (click)="treeControl.expandAll()">ExpandAll</button>

    <mat-tree [dataSource]="dataSource" [treeControl]="treeControl" class="example-tree">
        <mat-tree-node *matTreeNodeDef="let node" matTreeNodeToggle>
            {{node.name}}
        </mat-tree-node>
        <mat-nested-tree-node *matTreeNodeDef="let node; when: hasChild">
            <div class="mat-tree-node">
                <button mat-icon-button matTreeNodeToggle [attr.aria-label]="'Toggle ' + node.name">
                    <mat-icon class="mat-icon-rtl-mirror">
                        {{treeControl.isExpanded(node) ? 'expand_more' : 'chevron_right'}}
                    </mat-icon>
                </button>
                {{node.name}}
            </div>
            <div [class.example-tree-invisible]="!treeControl.isExpanded(node)" role="group">
                <ng-container matTreeNodeOutlet></ng-container>
            </div>
        </mat-nested-tree-node>
    </mat-tree>

</div>